"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var canvas_kit_react_core_1 = require("@workday/canvas-kit-react-core");
var canvas_kit_react_common_1 = require("@workday/canvas-kit-react-common");
var Tabs_1 = require("./Tabs");
var StyledButton = canvas_kit_react_common_1.styled('button')(__assign(__assign(__assign(__assign(__assign({}, canvas_kit_react_core_1.type.body), canvas_kit_react_core_1.type.variant.button), { border: 'none', backgroundColor: 'transparent', flex: '0 0 auto', maxWidth: '280px', padding: canvas_kit_react_core_1.spacing.s, boxSizing: 'border-box', cursor: 'pointer', color: canvas_kit_react_core_1.colors.licorice300, position: 'relative', marginLeft: "" + canvas_kit_react_core_1.spacing.xxxs, borderRadius: canvas_kit_react_core_1.borderRadius.m + " " + canvas_kit_react_core_1.borderRadius.m + " 0px 0px", transition: 'background 150ms ease, color 150ms ease', '&:first-of-type': {
        marginLeft: 0,
    } }), canvas_kit_react_common_1.hideMouseFocus), { '&:hover, &:focus': {
        backgroundColor: canvas_kit_react_core_1.colors.soap200,
        color: canvas_kit_react_core_1.colors.blackPepper400,
    }, '&:focus': __assign({ outline: "none" }, canvas_kit_react_common_1.focusRing({ inset: 'outer', width: 0, separation: 2 })) }), function (_a) {
    var isSelected = _a.isSelected;
    if (isSelected) {
        return {
            color: canvas_kit_react_core_1.colors.blueberry400,
            cursor: 'default',
            '&:after': {
                position: 'absolute',
                height: canvas_kit_react_core_1.spacing.xxxs,
                borderRadius: canvas_kit_react_core_1.borderRadius.m + " " + canvas_kit_react_core_1.borderRadius.m + " 0px 0px",
                backgroundColor: canvas_kit_react_core_1.colors.blueberry400,
                bottom: 0,
                content: "''",
                left: 0,
                marginTop: '-2px',
                width: '100%',
            },
            '&:hover, &:focus': {
                backgroundColor: "transparent",
                color: canvas_kit_react_core_1.colors.blueberry400,
            },
        };
    }
    return {};
});
var Tab = function (_a) {
    var _b = _a.name, name = _b === void 0 ? '' : _b, children = _a.children, elemProps = __rest(_a, ["name", "children"]);
    var _c = Tabs_1.useTab(), id = _c.id, intentTab = _c.intentTab, resetIntentTab = _c.resetIntentTab, activeTab = _c.activeTab, setActiveTab = _c.setActiveTab, setSelectedTabRect = _c.setSelectedTabRect, registerTab = _c.registerTab, unregisterTab = _c.unregisterTab;
    var tabRef = React.useRef(null);
    var _d = React.useState(name), tabName = _d[0], setTabName = _d[1];
    React.useLayoutEffect(function () {
        var tabElement = tabRef.current;
        var tabName = registerTab(tabElement, name);
        setTabName(tabName);
        return function () {
            unregisterTab(tabElement);
        };
    }, [name, registerTab, unregisterTab]);
    var onSelect = function () {
        setActiveTab(tabName);
    };
    var isSelected = !!tabName && activeTab === tabName;
    React.useLayoutEffect(function () {
        if (isSelected && tabRef.current) {
            setSelectedTabRect(tabRef.current.getBoundingClientRect());
        }
    }, [isSelected, tabRef, setSelectedTabRect, tabName, intentTab]);
    return (React.createElement(StyledButton, __assign({ ref: tabRef, role: "tab", id: "tab-" + id + "-" + tabName, tabIndex: !!tabName && intentTab === tabName ? undefined : -1, "aria-selected": isSelected ? true : undefined, "aria-controls": "tabpanel-" + id + "-" + tabName, onClick: onSelect, onBlur: resetIntentTab, isSelected: isSelected }, elemProps), children));
};
exports.default = Tab;
