import * as React from 'react';
import { TabListProps } from './TabList';
import { TabPanelProps } from './TabPanel';
interface TabsStateContextTypes {
    id: string;
    activeTab: string;
    setActiveTab: React.Dispatch<React.SetStateAction<string>>;
    intentTab: string;
    setIntentTab: (next: 'first' | 'last' | 'next' | 'previous') => void;
    resetIntentTab: () => void;
    registerTab: (element: HTMLElement, name?: string) => string;
    unregisterTab: (element: HTMLElement) => void;
    registerPanel: (name?: string) => string;
    unregisterPanel: (name: string) => void;
    selectedTabRect: ClientRect | null;
    setSelectedTabRect: React.Dispatch<React.SetStateAction<ClientRect>>;
    programmaticFocusRef: React.MutableRefObject<boolean>;
}
export declare const useTab: () => TabsStateContextTypes;
export declare type TabsChild = React.ReactElement<TabListProps> | React.ReactElement<TabPanelProps>;
export interface TabsProps extends React.HTMLAttributes<HTMLElement> {
    children: TabsChild[];
    initialTab?: string;
    onTabChange?: (name: string) => void;
}
declare const Tabs: {
    ({ children, initialTab, onTabChange, ...elemProps }: TabsProps): JSX.Element;
    List: ({ children, ...elemProps }: TabListProps) => JSX.Element;
    Item: ({ name, children, ...elemProps }: import("./Tab").TabProps) => JSX.Element;
    Panel: ({ children, name, ...elemProps }: TabPanelProps) => JSX.Element;
};
export default Tabs;
//# sourceMappingURL=Tabs.d.ts.map